/* Get enabled floating-point exceptions.
   Copyright (C) 2001-2017 Free Software Foundation, Inc.
   Contributed by Andreas Jaeger <aj@suse.de>, 2001.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <http://www.gnu.org/licenses/>.  */

#include <fenv.h>

int
fegetexcept (void)
{
  unsigned short int exc;

  /* Get the current control word.  */
  __asm__ ("fstcw %0" : "=m" (*&exc));

  return (~exc) & FE_ALL_EXCEPT;
}
